/*
gen_example1.c: prints out IDMEF XML message based on contents of IDMEFmessage
Author: Adam Migus, NAI Labs, (amigus@nai.com)

Copyright (c) 2001 Networks Associates Technology, Inc.
All rights reserved

This library is released under the GNU GPL and BSD software licenses.
You may choose to use one or the other, BUT NOT BOTH.  The GNU GPL
license is located in the file named COPYING.  The BSD license is located
in the file named COPYING.BSD.  Please contact us if there are any
questions.

$Id: gen_example1.c,v 1.3 2002/02/20 23:54:28 amigus Exp $

*/

/*
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <libidmef/idmefxml_parse.h>
#include <libidmef/idmefxml_gen.h>

char *program = 0;

int usage(char *p) {
	fprintf(stdout, "usage: %s <IDMEF xml file>\n", p);
	return 1;
}

int
main(int argc, char **argv) {
	IDMEFmessage *message = 0; 
	char *p = 0;

	program = ((p = strrchr(argv[0], '/')) ? ++p : argv[0]);

	if(argc != 2) return usage(program);

	message = get_idmef_message_from_file(argv[1]);	

	p = generate_idmef_message(message);

	fprintf(stdout, p);

	exit(0);
}
