/*
idmefxml_gen.h: header file for libidmef message generation functions
Author: Adam Migus, NAI Labs, (amigus@nai.com)

Copyright (c) 2001 Networks Associates Technology Inc.

This library is released under the GNU GPL and BSD software licenses.
You may choose to use one or the other, BUT NOT BOTH.  The GNU GPL
license is located in the file named COPYING.  The BSD license is located
in the file named COPYING.BSD.  Please contact us if there are any
questions.

*/

#ifndef _IDMEFXML_GEN_H
#define _IDMEFXML_GEN_H

/* $Id: idmefxml_gen.h,v 1.3 2002/02/20 23:54:28 amigus Exp $ */

#include "idmefxml_types.h"

#define IDMEF_MESSAGE_DTD "idmef-message.dtd"
#define XML_VERSION "1.0"

char *generate_idmef_message(IDMEFmessage *message);

xmlNodePtr build_address(IDMEFaddress *address);
xmlNodePtr build_userid(IDMEFuserid *userid);
xmlNodePtr build_user(IDMEFuser *user);
xmlNodePtr build_SNMPservice(IDMEFSNMPservice *SNMPservice);
xmlNodePtr build_webservice(IDMEFwebservice *webservice);
xmlNodePtr build_service(IDMEFservice *service);
xmlNodePtr build_process(IDMEFprocess *process);
xmlNodePtr build_node(IDMEFnode *node);
xmlNodePtr build_source(IDMEFsource *source);
xmlNodePtr build_fileaccess(IDMEFfileaccess *fileaccess);
xmlNodePtr build_linkage(IDMEFlinkage *linkage);
xmlNodePtr build_inode(IDMEFinode *inode);
xmlNodePtr build_file(IDMEFfile *file);
xmlNodePtr build_filelist(IDMEFfilelist *filelist);
xmlNodePtr build_target(IDMEFtarget *target);
xmlNodePtr build_classification(IDMEFclassification *classification);
xmlNodePtr build_analyzer(IDMEFanalyzer *analyzer);
xmlNodePtr build_impact(IDMEFimpact *impact);
xmlNodePtr build_action(IDMEFaction *action);
xmlNodePtr build_confidence(IDMEFconfidence *confidence);
xmlNodePtr build_assessment(IDMEFassessment *assessment);
xmlNodePtr build_toolalert(IDMEFtoolalert *toolalert);
xmlNodePtr build_overflowalert(IDMEFoverflowalert *overflowalert);
xmlNodePtr build_correlationalert(IDMEFcorrelationalert *correlationalert);
xmlNodePtr build_additionaldata(IDMEFadditionaldata *additionaldata);
xmlNodePtr build_alert(IDMEFalert *alert);
xmlNodePtr build_heartbeat(IDMEFheartbeat *heartbeat);
xmlNodePtr build_idmef_message(IDMEFmessage *message);

#endif /* _IDMEFXML_GEN_H */
